Redmine - Feature #4272

Add or remove columns from the issue list
2009-11-23 20:43 - Eric Davis

Status: Closed Start date: 2009-11-23
Priority: Normal Due date:

Assignee: Eric Davis % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 0.9.0

Resolution:

Description

This patch adds a context menu to the issue list's headers. It's activated by the right click and will allow a user to add or remove
specific columns from the table of issues. These columns are saved into the user's session so they will persist from page view to
page view and can be saved into a Saved Query.

This feature has used in production for almost 18 months but I'd like a quick code review to make sure | got all of the bugs during the

extraction.
« # ¥ Project Tracker Status Priority Subject Assigned to Updated [
O 442 Copy 1 Bug New | Medium Down-sized discrete emulation o Project McDermott 11/20/2009 02:35 pm
O 441 Copy 1 Bug New Low  Right-sized directional implementation o Tracker mylle 09/03/2009 04:13 pm

o Status Enberg
O 1 Bug New Low  Proactive multi-state hub & Priority McDermott 09/03/2009 0413 pm
O 1 Bug New Low  Grass-roots client-server knowledge user o Subject Gerhold 09/03/2009 04:13 pm
O y1| Bug New High Robust disintermediate standardization Author cDermott |09/03/2009 04:13 pm
O y 1 Bug New | Medium Future-proofed neutral model  Assigned to mylle 07/21/2009 05:19 pm
& Updated enberg
O 1 Bug New High Upgradable attitude-oriented neural-net Category Waelchi 09/03/2009 04:12 pm
O 1 Bug Wew | Medium Managed dedicated hierarchy Target version kUser 07/21/2009 05:19 pm
O v 1 Bug New  Medium Re-contextualized demand-driven help-de Start McDermott 09/03/2009 0412 pm
O y 1 Bug New High Cloned local monitoring « Due date hBayer 09/03/2009 04:12 pm
| y 1 Bug New High Reverse-engineered attitude-oriented prc Estimsted time Wisozk 09/03/2009 04:12 pm
improvement % Done

O Bug MNew High |Optional value-added system engine Created Gawayn 09/03/2009 04:12 pm
O ¥ Bug New  Medium Phased 4th generation worlkforce Test L User 09/03/2009 04:12 pm
This was designed and sponsored by Shane and Peter Inc.

Related issues:

Related to Redmine - Feature #1191: Allow custom column choice in issue browser Closed 2008-05-06

Associated revisions

Revision 3105 - 2009-11-28 12:34 - Jean-Philippe Lang

Adds dynamic columns selection on the issue list (#4272).

Revision 3106 - 2009-11-28 12:59 - Jean-Philippe Lang

Adds 2 buttons to easily reorder selected columns (#4272).

History

#1 - 2009-11-23 20:59 - Shane Peariman

| use this feature daily. Super useful!! +1

Future request - drag sorting.

#2 - 2009-11-23 21:31 - Jean-Philippe Lang

The feature is really a must have.

About the patch: very nice, but if you want to add/remove multiple columns, lots of clicks and requests are required which makes the whole process a
bit long.
A simple form with multiple checkboxes (under the "Options" fieldset for example) would make it much simpler for the user and would simplify the
code a lot.

#3 - 2009-11-24 13:55 - Henrik Ammer
| agree, it would better stored under Options.
+1 for drag sorting!
#4 - 2009-11-25 02:47 - Eric Davis
Jean-Philippe Lang wrote:
A simple form with multiple checkboxes (under the "Options" fieldset for example) would make it much simpler for the user and would simplify
the code a lot.
| agree, it would:
e simplify the code implementation
* make the feature more discoverable

¢ could save some effort (clicks) for multiple columns

FYI: This feature predates the Filter Options, being able to hide the fieldsets, or being able to edit the filters on saved issues. So that's why we used
the context menus. ;)

#5 - 2009-11-25 09:54 - Jean-Baptiste Barth

| tried this and found it was very cool :) ! | think checkboxes could be even better as Jean-Philippe said.

Just one more thing : from a user point of view, it's not very intuitive to wait 1,2,3 seconds after the menu has gone and wait icon disappeared (I admit
my server may be slow..). Maybe you should keep the "loading" icon and message in the foreground until column has effectively been
added/removed.

#6 - 2009-11-25 20:25 - Eric Davis
Jean-Baptiste Barth wrote:
Just one more thing : from a user point of view, it's not very intuitive to wait 1,2,3 seconds after the menu has gone and wait icon disappeared (|

admit my server may be slow..). Maybe you should keep the "loading" icon and message in the foreground until column has effectively been
added/removed.

That sounds like a server/browser slowness. The "Loading" icon is shown by Redmine automatically whenever an Ajax action is taking place. The
response from the server should just refresh the page with the new column, so the browser might be running that code slowly.

#7 - 2009-11-25 21:57 - Jean-Philippe Lang

- File dynamic-issue-columns-2.patch added

Here is a quick patch.
It's ugly and need some styling but it seems to work.

#8 - 2009-11-25 22:52 - Shane Pearlman
Jean-Philippe (or anyone else who applied the patch from comment 7), any chance we could get a quick screen shot? | can pretty much imagine what

you did but it would be nice to see it before | throw my support in.

#9 - 2009-11-25 23:08 - Jean-Philippe Lang
- File columns.png added

As | said, it's ugly and needs styling. But here it is:
o Apply Clear | Save

o+ # Tracker Status Priority Subject Updated

4291 nafert | A[=Tr Mormal Nefert #4265 SONT-11-24 2311
Especially, it would prefer to display columns vertically (to reflect the column order) with a fixed height. Many custom fields can make the columns list
pretty long.

What about using a similar Ul as on the query form (eg. http://www.redmine.org/queries/new) for the columns selection ?

#10 - 2009-11-25 23:48 - Eric Davis
Jean-Philippe Lang wrote:
Especially, it would prefer to display columns vertically (to reflect the column order) with a fixed height. Many custom fields can make the

columns list pretty long.
What about using a similar Ul as on the query form (eg. http://www.redmine.org/queries/new) for the columns selection ?

Using the query form was exactly what | was thinking also when you suggested checkboxes on the 23rd. If we did that, then:

1. The saved query and "on the fly" query would have matching Uls.
2. You could rearrange the order of the columns for an "on the fly" query.

#11 - 2009-11-28 12:31 - Jean-Philippe Lang
- Subject changed from Context menu to add or remove columns from the issue list to Add or remove columns from the issue list
- Status changed from 7 to Closed

- Target version set to 0.9.0

Feature added in r3105, using a similar Ul as on the query form.
Columns can now be dynamically selected and reordered from the issue list under "Options".

#12 - 2009-11-28 12:55 - Jean-Philippe Lang
- File columns-2.png added

Also added buttons to reorder columns. Here is how it looks like:

Issues
#13 - 2009-11-28 12:56 - Jean-Philippe Lang

- Tracker changed from Patch to Feature

#14 - 2009-11-28 13:36 - Jean-Philippe Lang
http://www.redmine.org/queries/new
http://www.redmine.org/queries/new
https://www.redmine.org/projects/redmine/repository/svn/revisions/3105

| think that in the Eric's patch, columns are preserved even when clearing the query.
In current implementation, columns are cleared back to default.
What is the preferred behaviour?

#15 - 2009-11-30 16:51 - Eric Davis

Since the columns are visible with the Filter Options, as a user | would associate them with the filters. So clearing them when | clear the filters would
be the behavior | would expect.

#16 - 2009-12-02 03:29 - Shane Pearlman

| agree with eric, | would like them to work in conjunction with the filter state. Nice update JPL.

#17 - 2009-12-03 01:44 - Doug Crawford

Any chance you could also add the issue Description as a optional dispplay field (default off). | know it will be a lot of text and will make the issue
table very long. But, sometimes it is nice to print out a list of the key issues someone is working on along with the detailed description of each issue.

#18 - 2009-12-20 06:40 - John Waldorff
This is a great enhancement that | would love to see in the core or as a plugin.
But | cannot apply this one automatical with Windows tortoiseCVS,

because this is just a diff and not a real patch:
dynamic-issue-columns.patch - Patch to trunk from r3084 (15.6 KB) Eric Davis, 2009-11-23 20:43

The other patch works just fine:
dynamic-issue-columns-2.patch

So | used the program "patch for windows" http://gnuwin32.sourceforge.net/packages/patch.htm
Then | found that it fails with most of the positions in the files and gave up for now.

Could someone please upload a recent patch file that contains both patches?
#19 - 2009-12-20 11:39 - Felix Schéfer
John Waldorff wrote:
Could someone please upload a recent patch file that contains both patches?
John, this has already found its way into trunk (with some small modifications IIRC), and will be part of 0.9, for which an RC is due in 2 to 3 weeks, so

I'm not sure if anyone will be really willing to spend the time updating the patch rather than working on getting the RC out. If you really need it before
then, I'd just recommend running trunk until 0.9 is released, If haven't had any problems with it in the few months since | installed it.

#20 - 2009-12-20 16:01 - John Waldorff
Thank you Felix - that helped me. Then | will also wait for this new feature.

| was not able to see that this patch is already in the trunk.
Could you probably give me one hint where to look at here in the tracker or how to proceed to check this with future patches?

Thanks again.

#21 - 2009-12-24 19:44 - Eric Davis

John Waldorff wrote:

Could you probably give me one hint where to look at here in the tracker or how to proceed to check this with future patches?

Check the Status and Target Version fields. Also Note 11 says it was added.

Files

dynamic-issue-columns.patch 15.6 KB 2009-11-23 Eric Davis
dynamic-issue-column.png 80.7 KB 2009-11-23 Eric Davis
dynamic-issue-columns-2.patch 1.79 KB 2009-11-25 Jean-Philippe Lang
columns.png 5.02 KB 2009-11-25 Jean-Philippe Lang
columns-2.png 11.7 KB 2009-11-28 Jean-Philippe Lang
